using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using Microsoft.AspNetCore.Authorization;
using System.Web;
using MySystem.Models;
using LitJson;
using Library;

namespace MySystem.Areas.Api.Controllers.v1
{
    [Area("Api")]
    [Route("Api/v1/[controller]/[action]")]
    public class UsersController : BaseController
    {
        public UsersController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
        }




        #region 通用-获取Token
        // [Authorize]
        public JsonResult GetToken(string value)
        {
            // value = DesDecrypt(value);
            function.WriteLog(DateTime.Now.ToString() + "\n" + value + "\n\n", "通用-获取Token");
            JsonData data = JsonMapper.ToObject(value);
            string AppId = data["AppId"].ToString(); //AppId
            string AppSecret = data["AppSecret"].ToString(); //AppSecret
            Dictionary<string, object> Obj = new Dictionary<string, object>();
            Users query = db.Users.FirstOrDefault(m => m.AppId == AppId && m.AppSecret == AppSecret);
            if(query != null)
            {
                Obj.Add("Token", function.MD5_32(AppId + "G9&E@952")); //用户令牌
            }
            else
            {
                return Json(new AppResultJson() { Status = "-1", Info = "获取失败，AppId或AppSecret有误", Data = Obj });
            }
            return Json(new AppResultJson() { Status = "1", Info = "", Data = Obj });
        }
        #endregion



        #region 检查签名是否合法，合法返回1，不合法返回提示信息

        /// <summary>
        /// 检查签名是否合法，合法返回1，不合法返回提示信息
        /// </summary>
        /// <param name="value">请求的参数(json字符串)</param>
        /// <param name="signField">要签名的字段</param>
        /// <returns></returns>
        private string CheckSign(string value, string[] signField)
        {
            JsonData json = JsonMapper.ToObject(value);
            Dictionary<string, string> dic = new Dictionary<string, string>();
            for (int i = 0; i < signField.Length; i++)
            {
                dic.Add(signField[i], json[signField[i]].ToString());
            }
            string sign = json["sign"].ToString(); //客户端签名字符串
            return new Sign().sign(dic, sign);
        }

        #endregion

    }
}
